﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.IO;
using System.Reflection;


namespace csv_param
{
    public partial class Form1 : Form
    {
        //Parameterを読み出す
        enum ParamKey
        {
            test,
            hoge,
            str,
        }

        //Parameter
        readonly Dictionary<ParamKey, object> Param = new Dictionary<ParamKey, object>();

        //AppPath
        readonly string AppPath = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location);


        public Form1()
        {
            InitializeComponent();

            SetComboBox();  //コンボボックス設定

            ReadParameterFile();
        }

        private void SetComboBox()
        {
            comboBoxKey.Items.Clear();
            comboBoxKey.Items.AddRange(Enum.GetNames(typeof(ParamKey)));
        }

        private void ReadParameterFile()
        {
            string fp = AppPath + @"\Parameter.csv";

            Encoding encoding = Encoding.GetEncoding("Shift_JIS");
            using (StreamReader sr = new StreamReader(fp, encoding))
            {
                //ヘッダーをスキップ
                sr.ReadLine();

                //最終行まで読み込み
                while (sr.Peek() != -1)
                {
                    string line = sr.ReadLine();
                    string[] dts = line.Split(',');

                    //文字列を列挙体に変換する
                    ParamKey key = (ParamKey)Enum.Parse(typeof(ParamKey), dts[0]);
                    object value = dts[1];

                    //ディクショナリに登録
                    Param.Add(key,value);
                }

            }
        }

        private void ComboBoxKey_SelectedIndexChanged(object sender, EventArgs e)
        {
            ParamKey key = (ParamKey)Enum.Parse(typeof(ParamKey), comboBoxKey.Text);
            labelValue.Text = Param[key].ToString();
        }
    }
}
